Codeforces Round #726 (Div. 2)

Codeforces Round #726 (Div. 2)

A. Arithmetic Array

题意:

题解:

代码:

#include <bits/stdc++.h>

#define int long long
#define debug(x) cout << #x << " = " << x << endl;
using namespace std;

inline int rd() {
   int s = 0, w = 1;
   char ch = getchar();
   while (ch < '0' || ch > '9') {if (ch == '-') w = -1; ch = getchar();}
   while (ch >= '0' && ch <= '9') s = s * 10 + ch - '0', ch = getchar();
   return s * w;
}

int const MAXN = 2e5 + 10;
int n, m, T, a[MAXN];

signed main() {
    cin >> T;
    while(T--) {
        cin >> n;
        int sum = 0;
        for (int i = 1; i <= n; ++i) cin >> a[i], sum += a[i];
        if (sum > n) cout << sum - n << endl;
        else if (sum == n) cout << 0 << endl;
        else cout << 1<< endl;
    }
    return 0;
}

B. Bad Boy

题意:

题解:

代码:

#include <bits/stdc++.h>

#define int long long
#define debug(x) cout << #x << " = " << x << endl;
using namespace std;

inline int rd() {
   int s = 0, w = 1;
   char ch = getchar();
   while (ch < '0' || ch > '9') {if (ch == '-') w = -1; ch = getchar();}
   while (ch >= '0' && ch <= '9') s = s * 10 + ch - '0', ch = getchar();
   return s * w;
}

int const MAXN = 2e5 + 10;
int n, m, T;
int x[10], y[10];

signed main() {
    cin >> T;
    while(T--) {
        int x1, y1;
        cin >> n >> m >> x1 >> y1;
        x[0] = 1, y[0] = 1;
        x[1] = 1, y[1] = m;
        x[2] = n, y[2] = 1;
        x[3] = n, y[3] = m;
        int Max = -1;
        int resx1 = 0, resy1 = 0;
        int resx2 = 0, resy2 = 0;
        for (int i = 0; i <=3; ++i) {
            for (int j = 0; j <= 3; ++j) {
                // if (i == j) continue;
                // if (x[i] == x1 && y[i] == y1) continue;
                // if (x[j] == x1 && y[j] == y1) continue;
                int tmp = abs(x[i] - x1) + abs(y[i] - y1) + abs(x[i] - x[j]) + abs(y[i] - y[j]) + abs(x[j] - x1) + abs(y[j] - y1);
                // cout << x[i] << " " << y[i] << " " << x[j] << " " << y[j] << " " << tmp << endl;
                if (tmp > Max) {
                    Max = tmp;
                    
                    resx1 = x[i], resy1 = y[i];
                    resx2 = x[j], resy2 = y[j];
                }
            }
        }
        cout << resx1 << " " << resy1 << " " << resx2 << " " << resy2 << endl;
    }
    return 0;
}

C. Challenging Cliffs

题意: 给定一个长度为n的数组a,要求将数组a重新排列。使得保证 ∣ a 1 − a n ∣ |a_1-a_n| a1an 最小的情况下,使得 a i < a i + 1 a_i<a_{i+1} ai<ai+1 的个数最少。 1 < = t < = 100 , 2 < = n < = 2 ∗ 1 0 5 , 1 < = a i < = 1 0 9 1<=t<=100, 2<=n<=2*10^5,1<=a_i<=10^9 1<=t<=100,2<=n<=2105,1<=ai<=109

题解: 贪心。将数组 a a a 从小到大排序,然后找到距离最近的两个 a i a_i ai a i + 1 a_{i+1} ai+1 ,然后按照 a i + 1 , a i + 2 , . . . , a n , a 1 , a 2 , . . . , a i a_{i+1}, a_{i+2}, ..., a_n, a_1, a_2, ...,a_i ai+1,ai+2,...,an,a1,a2,...,ai 排序,这样 a i < a i + 1 a_i < a_{i+1} ai<ai+1 的个数为 n − 2 n-2 n2

代码:

#include <bits/stdc++.h>

#define int long long
#define debug(x) cout << #x << " = " << x << endl;
using namespace std;

inline int read() {
   int s = 0, w = 1;
   char ch = getchar();
   while (ch < '0' || ch > '9') {if (ch == '-') w = -1; ch = getchar();}
   while (ch >= '0' && ch <= '9') s = s * 10 + ch - '0', ch = getchar();
   return s * w;
}

int const MAXN = 2e5 + 10;
int n, m, T;
int a[MAXN];

signed main() {
    cin >> T;
    while(T--) {
        cin >> n;
        for (int i = 1; i <= n; ++i) cin >> a[i];
        sort(a + 1, a + 1 + n);
        if (n == 2) {
            for (int i = 1; i <= n; ++i) cout << a[i] << " ";
            continue;
        }
        int Min = 1e18, idx = 1;
        for (int i = 1; i <= n - 1; ++i) {
            if (a[i + 1] - a[i] < Min) {
                Min = a[i + 1] - a[i];
                idx = i;
            }
        }
        for (int i = idx + 1; i <= n; ++i) cout << a[i] << " ";
        for (int i = 1; i <= idx; ++i) cout << a[i] << " ";
        puts("");
    }
    return 0;
}

D. Deleting Divisors

题意: A和B玩博弈论游戏,A先手。每次操作允许将当前数字n减去它的一个因子d,但是要求 d ≠ 1   & &   d ≠ n d \neq 1\ \&\&\ d \neq n d=1 && d=n。不能操作的人输。现在给定n,问你先手必胜还是后手必胜。 1 < = t < = 1 0 4 , 1 < = n < = 1 0 9 1<=t<=10^4, 1<=n<=10^9 1<=t<=104,1<=n<=109

题解: 博弈+分类讨论。

  1. 如果n为偶数:

    1. n不是 2 k 2^k 2k ,那么n减掉一个因子后,变为奇数,最后一定是1或者一个质因子,那么该状态为必胜态。
    2. n是 2 k 2^k 2k ,那么如果减掉一个因子,仍然是偶数。如果变为非 2 k 2^k 2k, 则对手必胜,因此必然减去 2 k − 1 2^{k-1} 2k1 ,那么变为 2 k − 1 2^{k-1} 2k1。这样的话,如果k为奇数,那么先手必败;如果k为偶数,那么先手必胜。
  2. 如果n为奇数:

    1. 如果n为1或者质数,必败态
    2. 如果n为其他数字,那么减去一个因子后,必然转换为非 2 k 2^k 2k 型的偶数,那么对手变为必胜态,则当前状态为必败态

    因此,如果n为奇数,为必败态

代码:

#include <bits/stdc++.h>

#define int long long
#define debug(x) cout << #x << " = " << x << endl;
using namespace std;

inline int read() {
   int s = 0, w = 1;
   char ch = getchar();
   while (ch < '0' || ch > '9') {if (ch == '-') w = -1; ch = getchar();}
   while (ch >= '0' && ch <= '9') s = s * 10 + ch - '0', ch = getchar();
   return s * w;
}

int const MAXN = 2e5 + 10;
int n, m, T;

signed main() {
    cin >> T;
    while(T--) {
        cin >> n;
        if (n & 1) {
            cout << "Bob\n";
            continue;
        }
        int cnt = 0;
        while(n % 2 == 0) {
            n /= 2;
            cnt++;
        }
        if (n == 1) {
            if (cnt & 1) cout << "Bob\n";
            else cout << "Alice\n";
        }
        else {
            cout << "Alice\n";
        }
    }
    return 0;
}

E1. Erase and Extend (Easy Version)

题意: 给定一个长度为n的字符串s,每次操作可以删去s的最后一个字符,或者s = s + s。问如何操作使得当s长度为m时的字典序最小,打印这个最小字典序的字符串。 1 < = n , k < = 5000 1<=n,k<=5000 1<=n,k<=5000

题解: 结论+贪心。有个结论:最后字符串必然是s的某个前缀重复若干次得到,因此直接枚举s的前缀,然后暴力得到所有长度为m的字符串,比较字典序即可。

代码:

#include <bits/stdc++.h>

#define int long long
#define debug(x) cout << #x << " = " << x << endl;
using namespace std;

inline int rd() {
   int s = 0, w = 1;
   char ch = getchar();
   while (ch < '0' || ch > '9') {if (ch == '-') w = -1; ch = getchar();}
   while (ch >= '0' && ch <= '9') s = s * 10 + ch - '0', ch = getchar();
   return s * w;
}

int const MAXN = 2e5 + 10;
int n, m, T;
string s;
string ss[MAXN];

signed main() {
    cin >> n >> m;
    cin >> s;
    string pre = "";
    for (int i = 1; i <= n; ++i) {
        pre += s[i - 1];
        ss[i] = "";
        int t = (int)ceil((double)m / (double)i);
        for (int j = 1; j <= t; ++j) ss[i] += pre;
        ss[i].resize(m);
        // cout << ss[i] << endl;
    }
    sort(ss + 1, ss + 1 + n);
    cout << ss[1];
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值